;----------------------------------------;
;   PODPROGRAMY PRO PRACI S INTERVALEM   ;
;----------------------------------------;

; ze vstupu spocte interval [ 7/8 , 9/8 ], kde 1 = vstup
INTERVAL_	MACRO	VSTUP,I_MINUS,I_PLUS,ADIT_CH
;  VSTUP - vstupni 16bitova hodnota
;  I_MINUS - 16bitova dolni mez intervalu
;  I_PLUS  - 16bitova horni mez intervalu
;  ADIT_CH - predpokladana aditivni chyba (maximalne 255)
	LOCAL	DALSI

	RRF	VSTUP+1,W	; provadime deleni cislem 8 ukladame jej do I_PLUS
	MOVWF	I_PLUS+1
	RRF	VSTUP,W
	MOVWF	I_PLUS
	RRF	I_PLUS+1,F
	RRF	I_PLUS,F
	RRF	I_PLUS+1,W
	ANDLW	B'00011111'
	MOVWF	I_PLUS+1
	XORLW	D'255'
	MOVWF	I_MINUS+1	; do I_MINUS ukladame negaci I_PLUS, coz je v podstate " -I_PLUS - 1 "
	RRF	I_PLUS,W
	MOVWF	I_PLUS
	XORLW	D'255'
	MOVWF	I_MINUS
	MOVLW	ADIT_CH	; do I_PLUS pricitame odhad aditivni chyby
	ADDWF	I_PLUS,F
	BTFSC	STATUS,C
	INCF	I_PLUS+1,F
	MOVLW	ADIT_CH	; stejny odhad aditivni chyby odecitame od I_MINUS
	SUBWF	I_MINUS,F
	BTFSS	STATUS,C
	DECF	I_MINUS+1,F
	; nyni mame tolerancni interval se stredem (temer) v nule
	; nasledujici program posune stred intervalu na hodnotu VSTUP
	MOVF	VSTUP,W	; k I_PLUS pricitame VSTUP
	ADDWF	I_PLUS,F
	MOVF	VSTUP+1,W
	BTFSC	STATUS,C
	INCFSZ	VSTUP+1,W
	ADDWF	I_PLUS+1,F
	BTFSS	STATUS,C
	GOTO	DALSI
	MOVLW	D'255'	; osetreni preteceni
	MOVWF	I_PLUS
	MOVWF	I_PLUS+1
DALSI	MOVF	VSTUP,W
	ADDWF	I_MINUS,F	; nyni pricitame VSTUP k I_MINUS
	MOVF	VSTUP+1,W
	BTFSC	STATUS,C
	INCFSZ	VSTUP+1,W
	ADDWF	I_MINUS+1,F
	BTFSC	STATUS,C
	GOTO	$ + 3
	CLRF	I_MINUS	; osetreni zaporne hodnoty (podteceni)
	CLRF	I_MINUS+1

	ENDM

; testuje, zda VSTUP lezi v intervalu [I_MINUS,I_PLUS]
UVNITR_	MACRO	VSTUP,I_MINUS,I_PLUS
;  VSTUP - 16bitova hodnota
;  I_MINUS - 16bitova dolni mez intervalu
;  I_PLUS  - 16bitova horni mez intervalu
; pokud je VSTUP v intervalu, potom se nastavi "STATUS,C" na jednicku,...
; ...v opacnem pripade zde bude nula

	LOCAL	KONEC

	MOVF	I_MINUS,W	; odecteme dolni mez od VSTUP
	SUBWF	VSTUP,W	; numericky vysledek zapominame
	MOVF	I_MINUS+1,W
	BTFSS	STATUS,C
	INCFSZ	I_MINUS+1,W
	SUBWF	VSTUP+1,W
	BTFSS	STATUS,C	; pokud je vysledek zaporny,...
	GOTO	KONEC	; ...potom koncime - VSTUP neni v intervalu
	MOVF	VSTUP,W	; v opacnem pripade...
	SUBWF	I_PLUS,W	; ...odecteme VSTUP od horni meze
	MOVF	VSTUP+1,W	; numericky vysledek zapominame
	BTFSS	STATUS,C
	INCFSZ	VSTUP+1,W
	SUBWF	I_PLUS+1,W
KONEC			; nyni je nastaven priznak ve STATUS,C
	ENDM
